import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.Random;

class Tarefa implements Runnable {

    private String nome;
    private int tempo;
    private static Random gerador = new Random();

    public Tarefa(String n){
       nome = n;
       tempo = gerador.nextInt(5000);   // sorteia um tempo de dormida de ate 5 segundos...
    }


    public void run() {
        try {
          System.out.printf("Thread %s : Eu vou dormir\n", nome);
          Thread.sleep(tempo);
	} 
        catch (InterruptedException e) {
             e.printStackTrace();
        }
  
        System.out.printf("Thread %s : acordei ! e terminei.....\n", nome);
    }

}

public class DemoExecutor {

    public static void main(String args[]) {

      Tarefa t1 = new Tarefa("tarefa1");
      Tarefa t2 = new Tarefa("tarefa2");
      Tarefa t3 = new Tarefa("tarefa3");

      // cria ExecutorService para executar as threads...
      ExecutorService es = Executors.newFixedThreadPool(3);

      System.out.println("iniciando as threads...");

      es.execute(t1);
      es.execute(t2);
      es.execute(t3);

      // encerra as threads trabalhadoras
      es.shutdown();


      System.out.println("Quando  que  isso vai ser impresso???? Vale ingresso seo da tarde...");

    }
}
